#COMPILE EXE '#Win 10.04#
#DIM ALL
#REGISTER NONE
#INCLUDE "Win32Api.inc"
#INCLUDE "CommCtrl.inc" 'Needed if manifest and WinXP
#INCLUDE "ComDlg32.inc"
#RESOURCE "CrLfTabSpc.pbr"

%Comctl32v6 = %TRUE 'If using Common control v6 via a manifest

$AppName = "CrLfTabSpc"
%Window  = 3
%Unix    = 2
%Mac     = 1
%Stat    = 4

GLOBAL hDlg AS DWORD
GLOBAL pEditProc AS DWORD

%OptionViewAsText              = 101
%OptionViewAsHex               = 102
%OptionViewCount               = 103
%OptionViewHelp                = 104

%OptionCrlfWindows             = 111
%OptionCrlfUnix                = 112
%OptionCrlfMac                 = 113
%OptionCrlfNoConversion        = 114

%OptionTabToSpace              = 121
%OptionTabFromSpace            = 122
%OptionTabNoConversion         = 123

%OptionBelow32Spc              = 131
%OptionBelow32Custom           = 132
%OptionBelow32Braket           = 133
%OptionBelow32SpcCharNoConvert = 134

%LabelTab                      = 201

%Edit                          = 301
%EditTabLen                    = 302
%EditCtrlChar                  = 303

%ButtonBelow32Char             = 401
%ButtonAbove127                = 402
%ButtonLFCR                    = 403
%ButtonCharZero                = 404
%ButtonTab                     = 405
%ButtonConvert                 = 406
%ButtonClip                    = 407
%ButtonSave                    = 408
%ButtonSaveAs                  = 409

'_____________________________________________________________________________

FUNCTION WinError$(BYVAL ErrorCode AS DWORD) AS STRING
 LOCAL pzError  AS ASCIIZ POINTER 'Max is 64K
 LOCAL ErrorLen AS DWORD

 ErrorLen = FormatMessage(%FORMAT_MESSAGE_FROM_SYSTEM OR %FORMAT_MESSAGE_ALLOCATE_BUFFER, _
                          BYVAL %NULL, ErrorCode, %NULL, BYVAL VARPTR(pzError), %NULL, BYVAL %NULL)
 IF ErrorLen THEN
   #IF %DEF(%PB_CC32)
   CharToOem(BYVAL pzError, BYVAL pzError) 'Console characters
   #ENDIF
   FUNCTION = "Error" & STR$(ErrorCode) & " (0x" & HEX$(ErrorCode) & ") : " & @pzError
   LocalFree(pzError)
 ELSE
   FUNCTION = "Unknown error" & STR$(ErrorCode) & " (0x" & HEX$(ErrorCode) & ")"
 END IF

END FUNCTION
'_____________________________________________________________________________

FUNCTION FontCharSetEnum(elf AS ENUMLOGFONT, ntm AS NEWTEXTMETRIC, _
                     BYVAL FontType AS LONG, CharSet AS LONG) AS LONG
 'Get type of character set - ansi, symbol.. a must for some fonts.
 CharSet = elf.elfLogFont.lfCharSet

END FUNCTION
'_____________________________________________________________________________

FUNCTION FontMakeEx(BYVAL sFontName AS STRING, BYVAL PointSize AS LONG, BYVAL fBold AS LONG, _
                    BYVAL fItalic AS LONG, BYVAL fUnderline AS LONG) AS DWORD
 'Create a desirable font and return its handle. Original code by Dave Navarro
 'NOTE: enhanced with proper enumeration of character set via chmEnumFontDataProc
 LOCAL hDesktopDc      AS DWORD
 LOCAL CharSet  AS LONG
 LOCAL CyPixels AS LONG

 hDesktopDc      = GetDC(%HWND_DESKTOP)
 CyPixels = GetDeviceCaps(hDesktopDc, %LOGPIXELSY)
 EnumFontFamilies(hDesktopDc, BYVAL STRPTR(sFontName), CODEPTR(FontCharSetEnum), BYVAL VARPTR(CharSet))
 ReleaseDC(%HWND_DESKTOP, hDesktopDc)
 PointSize = 0 - (PointSize * CyPixels) \ 72

 FUNCTION = _
 CreateFont(PointSize, 0, _  'height, width(default=0)
 0, 0, _                     'escapement(angle), orientation
 fBold, _                    'weight (%FW_DONTCARE = 0, %FW_NORMAL = 400, %FW_BOLD = 700)
 fItalic, _                  'Italic
 fUnderline, _               'Underline
 %FALSE, _                   'StrikeThru
 CharSet, %OUT_TT_PRECIS, _
 %CLIP_DEFAULT_PRECIS, %DEFAULT_QUALITY, _
 %FF_DONTCARE , BYCOPY sFontName)

END FUNCTION
'_____________________________________________________________________________

FUNCTION ToolTipAdd(BYVAL hParent AS LONG, BYVAL idControl AS LONG, BYVAL sText AS STRING) AS LONG
 LOCAL  ComboInfo  AS COMBOBOXINFO
 LOCAL  ToolInf    AS TOOLINFO
 LOCAL  zClassName AS ASCIIZ * 50
 STATIC hToolTip   AS DWORD

 IF IsWindow(hToolTip) = %NULL THEN  'Create tooltip class if not already done
   hToolTip = CreateWindowEx(0, "tooltips_class32", "", %TTS_ALWAYSTIP, 0, 0, _ '%TTS_ALWAYSTIP OR %TTS_BALLOON
                             0, 0, 0, BYVAL 0, GetModuleHandle(BYVAL 0), BYVAL 0)
   SendMessage(hToolTip, %TTM_SETMAXTIPWIDTH, 0, 300)
   SendMessage(hToolTip, %TTM_SETDELAYTIME, %TTDT_AUTOPOP, 5000)'Set Tooltip time
 END IF

 IF hToolTip THEN 'Do we have a handle?
   IF SendMessage(hToolTip, %TTM_GETTOOLINFO, 0, BYVAL VARPTR(ToolInf)) THEN
     SendMessage(hToolTip, %TTM_DELTOOL, 0, BYVAL VARPTR(ToolInf)) 'Remove old tip if any
   END IF
   ToolInf.cbSize = SIZEOF(ToolInf)
   ToolInf.uFlags = %TTF_SUBCLASS OR %TTF_IDISHWND 'OR %TTF_DI_SETITEM
   IF idControl = 0 THEN
     ToolInf.uId = hParent 'If idControl = 0 then add tooltip to main dialog area
   ELSE
     ToolInf.uId = GetDlgItem(hParent, idControl) 'Add tooltip to control
   END IF
   ToolInf.hWnd     = hParent
   ToolInf.lpszText = STRPTR(sText)
   FUNCTION = SendMessage(hToolTip, %TTM_ADDTOOL, 0, BYVAL VARPTR(ToolInf))

   GetClassName(ToolInf.uId, zClassName, 50) ': GetClassName(ToolInf.hWnd, zClassName, 50)
   IF zClassName = "ComboBox" THEN 'Use edit part of combo
     ComboInfo.cbSize = SIZEOF(COMBOBOXINFO) ': MSGBOX zClassName 'STR$(ToolInf.hWnd)
     GetComboBoxInfo(ToolInf.uId, ComboInfo) ': MSGBOX HEX$(ComboInfo.hwndItem) & $CRLF & HEX$(hControl))
     ToolInf.hWnd     = ToolInf.uId
     ToolInf.uId      = ComboInfo.hwndItem
     SendMessage(hToolTip, %TTM_ADDTOOL, 0, BYVAL VARPTR(ToolInf))
   END IF
 END IF

END FUNCTION
'_____________________________________________________________________________

FUNCTION EditProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                  BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
 SELECT CASE wMsg

   CASE %WM_CHAR

     SELECT CASE wParam
       CASE 1 'Control-A
         SendMessage(hWnd, %EM_SETSEL, 0, - 1) 'Select everything
         EXIT FUNCTION
     END SELECT

 END SELECT

 FUNCTION = CallWindowProc(pEditProc, hWnd, wMsg, wParam, lParam)

END FUNCTION
'_____________________________________________________________________________

FUNCTION ClipBoardSet(BYVAL sBuffer AS STRING) AS LONG 'Updated 2011-02-17
 LOCAL pData      AS ASCIIZ POINTER
 LOCAL hClipboard AS DWORD

 IF IsClipboardFormatAvailable(%CF_TEXT) THEN  'See if clipboard contains data in text format
   IF OpenClipboard(hDlg) THEN                 'Open the clipboard
     EmptyClipboard()                          'Empties clipboard, frees handles to data and take ownership
     hClipboard = GlobalAlloc(%GMEM_MOVEABLE, LEN(sBuffer) + 1) 'Allocates bytes from the heap (GlobalSize)
     IF hClipboard THEN                        'Not null, so success
       pData  = GlobalLock(hClipboard)         'Locks a global memory object and get pData pointer
       @pData = sBuffer & $NUL                 'Set clipboard data
       GlobalUnlock(hClipboard)                'Unlock memory
       SetClipboardData(%CF_TEXT , hClipboard) 'Put data in clipboard
     END IF
     'No need for GlobalFree(hClipboard) 'Frees the global memory object and invalidates its handle
     CloseClipboard
   END IF
 END IF

END FUNCTION
'_____________________________________________________________________________

FUNCTION HexView$(sString AS STRING) AS STRING 'HexView HexString
 LOCAL  pByte   AS BYTE POINTER
 LOCAL  sBuffer AS STRING
 LOCAL  sChar16 AS STRING
 LOCAL  Looper  AS LONG

 pByte = STRPTR(sString)
 DO
   IF (Looper AND 15) = 00 THEN                 'Like MOD 16
     sBuffer = sBuffer & HEX$(Looper, 4) & ": " 'Line number:
   ELSEIF (Looper AND 07) = 00 THEN             'Like MOD 8
     sBuffer = sBuffer & "- "                   'Middle dash
   END IF

   IF Looper < LEN(sString) THEN                'Add data
     sBuffer = sBuffer & HEX$(@pByte[Looper], 2) & $SPC
   ELSE
     sBuffer = sBuffer & "   "                  'Console: No more data, fill with three spaces
   END IF

   IF (Looper AND 15) = 15 THEN                 'End of 16 bytes line
     sChar16 = MID$(sString, Looper -14, 16)    'Next line replace non visible characters with dot
     REPLACE ANY CHR$(0,1,9,10,13,27 TO 31,127,129,140,141,143,144,152,157) WITH ".................." IN sChar16
     sBuffer = sBuffer & "; " & sChar16 & $CRLF 'Add ascii string and CRLF
     IF Looper >= LEN(sString) - 1 THEN EXIT DO 'Job done
   END IF

   INCR Looper

 LOOP
 FUNCTION = "Text lenght is" & STR$(LEN(sString)) & " characters." & $CRLF & sBuffer

END FUNCTION
'_____________________________________________________________________________

 FUNCTION FileSave(sFilename AS STRING) AS STRING
 LOCAL ofn           AS OPENFILENAME
 LOCAL zTitle        AS ASCIIZ * 63
 LOCAL zFileTitle    AS ASCIIZ * %MAX_PATH + 1
'LOCAL zFile         AS ASCIIZ * %MAX_PATH + 1
 LOCAL zPath         AS ASCIIZ * %MAX_PATH + 1 'STRING
 LOCAL zFilename     AS ASCIIZ * %MAX_PATH + 1 'STRING
 LOCAL LastBackSlash AS LONG
 LOCAL sFilter    AS STRING

 zTitle              = $AppName & " - Save" '"Dialog title"
 ofn.lpstrTitle      = VARPTR(zTitle)
 ofn.nMaxFileTitle   = SIZEOF(zFileTitle)

 sFilter             = "BMP file (*.bmp)" & $NUL & "*.bmp" & $NUL & _
                       "All file (*.*)" & $NUL & "*.*" & $NUL & $NUL
 ofn.lpstrFilter     = STRPTR(sFilter)
 ofn.lpstrFileTitle  = VARPTR(zFileTitle)

 ofn.lStructSize     = SIZEOF(OPENFILENAME)
 ofn.hWndOwner       = hDlg
 ofn.nFilterIndex    = 1
 ofn.FlagsEx         = 0

 ofn.nMaxFile        = SIZEOF(zFilename)
 IF LEN(sFilename) THEN
   LastBackSlash = INSTR(-1, sFilename, "\")
   IF LastBackSlash THEN
     zPath         = LEFT$(sFilename, LastBackSlash)
     zFilename     = MID$(sFilename, LastBackSlash + 1)
     ofn.lpstrFile = VARPTR(zFilename)
   ELSE
     zPath = CURDIR$
   END IF
 ELSE
   zPath = CURDIR$
 END IF
 ofn.nMaxFile        = LEN(zFilename)
 zPath = CURDIR$
 ofn.lpstrInitialDir = VARPTR(zPath)

 ofn.Flags = %OFN_EXPLORER OR %OFN_ENABLESIZING OR _
             %OFN_FILEMUSTEXIST OR %OFN_NODEREFERENCELINKS OR %OFN_HIDEREADONLY

 IF GetSaveFilename(ofn) = 0 THEN 'Error if 0
   MSGBOX WinError$(GetLastError())
 ELSE
   FUNCTION = zFilename 'Path\File
 END IF

END FUNCTION
'_____________________________________________________________________________

FUNCTION FileGet(zFilename AS ASCIIZ) AS STRING
 LOCAL ofn         AS OPENFILENAME
 STATIC zInitialDir AS ASCIIZ * %MAX_PATH
 LOCAL zTitle      AS ASCIIZ * 50
 LOCAL sFilter     AS STRING
 LOCAL sFile       AS STRING

 zTitle               = $AppName & " - Select file(s)"
 ofn.lpstrTitle       = VARPTR(zTitle)

 sFilter             = "Ico files (*.ico)"    & $NUL & "*.ico" & $NUL & _
                       "Bmp files (*.bmp)"    & $NUL & "*.bmp" & $NUL & _
                       "All files (*.*)"      & $NUL & "*.*"   & $NUL & $NUL
 ofn.lpstrFilter     = STRPTR(sFilter)

 sFile               = STRING$(%Max_Path * 1, 0)
 ofn.lpstrFile       = STRPTR(sFile) 'Returned path\filename
 ofn.nMaxFile        = LEN(sFile)

 ofn.lStructSize     = SIZEOF(ofn)
 ofn.hWndOwner       = hDlg
 ofn.nFilterIndex    = 1

 IF zInitialDir = "" THEN
   zInitialDir       = CURDIR$
 END IF
 IF LEN(zFilename) THEN
   zInitialDir       = zFilename
 END IF

 ofn.lpstrInitialDir = VARPTR(zInitialDir)

 ofn.Flags = %OFN_EXPLORER OR %OFN_ENABLESIZING OR %OFN_ALLOWMULTISELECT OR _
             %OFN_FILEMUSTEXIST OR %OFN_NODEREFERENCELINKS OR %OFN_HIDEREADONLY

 IF GetOpenFileName(ofn) = 0 THEN 'Error if 0

 ELSE
   sFile = RTRIM$(sFile, $NUL)
   FUNCTION = sFile         'Path\File1\File2\File3\...
   zInitialDir = PARSE$(sFile, $NUL, 1)
 END IF

END FUNCTION
'_____________________________________________________________________________

FUNCTION Convert(BYREF sData AS STRING, BYVAL LFCR AS LONG, BYVAL TabLen AS LONG, Below32 AS LONG, _
                 zBelow32Char AS ASCIIZ * 1) AS LONG
 LOCAL Looper                AS LONG
 LOCAL DataSize              AS QUAD
 LOCAL pByte                 AS BYTE POINTER
 LOCAL pLastByte             AS BYTE POINTER
 LOCAL pDataToShiftEnd       AS BYTE POINTER
 LOCAL pDataToShiftStart     AS BYTE POINTER
 LOCAL pData                 AS BYTE POINTER
 LOCAL CrLfCount             AS LONG
 LOCAL CrCount               AS LONG
 LOCAL LfCount               AS LONG
 LOCAL LfAndCrCount          AS LONG
 LOCAL TabCount              AS LONG
 LOCAL TabInsertLen          AS LONG
 LOCAL TabAdd                AS LONG
 LOCAL TabIndex              AS LONG
 LOCAL Below32Count          AS LONG
 LOCAL Over127Count          AS LONG
 LOCAL ZeroCount             AS LONG
 LOCAL EscCount              AS LONG
 LOCAL Pass2                 AS LONG
 LOCAL ChunkLen              AS LONG

 pByte    = STRPTR(sData) 'Get a pointer to the data
 DataSize = LEN(sData) ': MSGBOX "pByte =0x" & HEX$(pByte)

 DO 'Replace $CR and $LF with $NUL but keep $CRLF characters pair
   IF @pByte[Looper] = 13 THEN 'Found a $CR
     IF @pByte[Looper + 1] = 10 THEN 'It's a $CRLF so keep it
       INCR CrLfCount
       IF LFCR = %Window THEN
         INCR Looper 'Bypass  next $LF
       ELSEIF LFCR = %Unix THEN
         @pByte[Looper] = 0 'Replace $CR with a $NUL, leave $LF
       ELSEIF LFCR = %Mac THEN
         @pByte[Looper + 1] = 0 'Replace $LF with a $NUL, leave $CR
       END IF
       INCR Looper 'Bypass  next $LF
     ELSE 'Single $CR not part of a $CRLF
       INCR CrCount
       IF LFCR = %Window THEN
         @pByte[Looper] = 0 'Replace $CR with a $NUL
       ELSEIF LFCR = %Unix THEN
         @pByte[Looper] = 10 'Replace $CR with a $LF
       ELSEIF LFCR = %Mac THEN
         'Do nothing, $CR = $CR
       END IF
     END IF
   ELSEIF @pByte[Looper] = 10 THEN 'Single $LF not part of a $CRLF
     INCR LfCount
     IF LFCR = %Window THEN
       @pByte[Looper] = 0 'Replace $LF with a $NUL
     ELSEIF LFCR = %Unix THEN
       'Do nothing, $LF = $LF
     ELSEIF LFCR = %Mac THEN
       @pByte[Looper] = 13 'Replace $LF with a $CR
     END IF
   ELSEIF @pByte[Looper] = 9 THEN
     INCR TabCount 'Found a $TAB
   ELSEIF @pByte[Looper] = 0 THEN
     INCR ZeroCount
   ELSEIF @pByte[Looper] = 27 THEN
     INCR EscCount
   ELSEIF @pByte[Looper] < 32 THEN
     INCR Below32Count
     IF Below32 THEN
       @pByte[Looper] = ASC(zBelow32Char) 'Since it's a byte for a byte, replace it right now
     END IF
   ELSEIF @pByte[Looper] > 127 THEN
     INCR Over127Count
   END IF
   INCR Looper
 LOOP WHILE Looper < DataSize

 LfAndCrCount = LfCount + CrCount

 IF LFCR = %Stat THEN 'Build sBuffer stat
  sData =                                              $CRLF & _
           "     Nul: " & FORMAT$(ZeroCount, "0,")    & $CRLF & _
           "     Tab: " & FORMAT$(TabCount, "0,")     & $CRLF & _
           "      CR: " & FORMAT$(CrCount, "0,")      & $CRLF & _
           "      LF: " & FORMAT$(LfCount, "0,")      & $CRLF & _
           "    CRLF: " & FORMAT$(CrLfCount, "0,")    & $CRLF & _
           "     Esc: " & FORMAT$(EscCount, "0,")     & $CRLF & _
           " Below32: " & FORMAT$(Below32Count, "0,") & $CRLF & _
           " Over127: " & FORMAT$(Over127Count, "0,") & $CRLF & _
           "     Len: " & FORMAT$(LEN(sData), "0,")   & $CRLF
  EXIT FUNCTION
 END IF

 IF TabLen > 0 THEN 'Min 1 space or zero to bypass
   TabLen = MIN&(TabLen, 16) 'Be reasonnable
   TabAdd = TabLen - 1 '$TAB (One char) to SPACE$(TabLen) (TabLen count char), min 1 space or zero to bypass
 ELSEIF TabLen < 0 THEN
   TabInsertLen = 0 - TabLen
   TabLen       = 0
 ELSE
   TabLen = 0
 END IF
 IF TabCount * TabLen  THEN Pass2 = %TRUE

 IF LFCR = %Window THEN
   IF LfCount THEN Pass2 = %TRUE
   IF CrCount THEN Pass2 = %TRUE
 ELSEIF LFCR = %Unix THEN
   IF CrLfCount THEN Pass2 = %TRUE
   IF CrCount   THEN Pass2 = %TRUE
 ELSEIF LFCR = %Mac THEN
   IF CrLfCount THEN Pass2 = %TRUE
   IF LfCount   THEN Pass2 = %TRUE
 END IF

 'Second pass, add needed blank space at the beginning of sData for $CR of $LF conversion to $CRLF
 'Doing it this way because string reassignment is a slow process
 'IF LfAndCrCount OR TabCount * TabLen THEN 'We have to replace $NUL, aka $LF or $CR, with $CRLF and/or $TAB with $SPACE$(TabLen)
 IF Pass2 THEN 'We have to replace $NUL, aka $LF or $CR, with $CRLF and/or $TAB with $SPACE$(TabLen)
   IF LFCR = %Window THEN
     sData           = SPACE$(LfAndCrCount + TabCount * TabAdd) & sData 'Add needed space at the beginning
     pData           = STRPTR(sData) 'Pointer to what will be the text start after shifting string is done
     pDataToShiftEnd = pData + LfAndCrCount + TabCount * TabAdd 'Pointer to the part that will be shifted to the left
     pLastByte       = pData + LEN(sData) - 1 '-1 'Reference for loop exit : PRINT "pLastByte " & HEX$(@pLastByte)
   ELSE '%Unix %Mac
     sData           = SPACE$(TabCount * TabAdd) & sData 'Add needed space at the beginning
     pData           = STRPTR(sData) 'Pointer to what will be the text start after shifting string is done
     pDataToShiftEnd = pData + TabCount * TabAdd 'Pointer to the part that will be shifted to the left
     pLastByte       = pData + LEN(sData) - 0 '-1 'Reference for loop exit : PRINT "pLastByte " & HEX$(@pLastByte)
   END IF

   pDataToShiftStart = pDataToShiftEnd 'Init before loop entrance
   DO
     IF @pDataToShiftEnd = 0 THEN 'A_B2_C03_D004_E0o05_F0o0o6_G0o0o07_H0o0o0o8_I0o0o0o09_Fin_ '
       IF LFCR = %Window THEN 'Replace $NUL with a $CRLF
         ChunkLen = pDataToShiftEnd - pDataToShiftStart 'Get the size of the string before next $NUL
         CopyMemory(pData, pDataToShiftStart, ChunkLen) 'Dst, Src, Len 'Shift the chunk to the left
         pDataToShiftStart = pDataToShiftEnd + 1 'Update $Nul old position
         pData             = pData + ChunkLen + 2 'Update new data pointer
         @pData[-2] = 13 '$CR
         @pData[-1] = 10 '$LF
       ELSE 'Unix or Mac - Remove possible $Nul from text
         ChunkLen = pDataToShiftEnd - pDataToShiftStart 'Get the size of the string before next $NUL
         CopyMemory(pData, pDataToShiftStart, ChunkLen) 'Dst, Src, Len 'Shift the chunk to the left
         pDataToShiftStart = pDataToShiftEnd + 01 'Bypass $Nul
         pData             = pData + ChunkLen + 0 'Update new data pointer
       END IF
     ELSEIF @pDataToShiftEnd = 9 THEN '$TAB A_B2_C03_D004_E0o05_F0o0o6_G0o0o07_H0o0o0o8_I0o0o0o09_Fin_ '
       IF TabLen THEN
         ChunkLen = pDataToShiftEnd - pDataToShiftStart 'Get the size of the string before next $NUL
         CopyMemory(pData, pDataToShiftStart, ChunkLen) 'Dst, Src, Len 'Shift the chunk to the left
         pDataToShiftStart = pDataToShiftEnd + 1 'Update $Nul old position
         pData             = pData + ChunkLen + TabLen 'Update new data pointer
         TabIndex              = TabLen
         DO
           @pData[-TabIndex] = 32 '+ 1 '$SPACE
           DECR TabIndex
         LOOP WHILE TabIndex
       END IF
     END IF
     INCR pDataToShiftEnd
   LOOP WHILE pDataToShiftEnd <= pLastByte

   IF CrLfCount THEN
    IF LFCR = %Unix THEN
      sData = LEFT$(sData, - CrLfCount)
    ELSEIF LFCR = %Mac THEN
      sData = LEFT$(sData, - CrLfCount)
    END IF '%Window
   END IF
 END IF

 IF TabInsertLen THEN
   REPLACE SPACE$(TabInsertLen) WITH $TAB IN sData
 END IF

END FUNCTION
'_____________________________________________________________________________

CALLBACK FUNCTION DlgProc
 LOCAL  zBelow32Char  AS ASCIIZ * 2
 STATIC sData         AS STRING
 LOCAL  sHex          AS STRING
 LOCAL  sBuffer       AS STRING
 LOCAL  sStat         AS STRING
 STATIC hEdit         AS DWORD
 STATIC hFontConsolas AS DWORD
 STATIC hFontOri      AS DWORD
 STATIC SelStart      AS LONG
 STATIC SelEnd        AS LONG
 LOCAL  TabLen        AS LONG
 LOCAL  Below32       AS LONG
 LOCAL  LFCR          AS LONG
 LOCAL  Looper        AS LONG

 SELECT CASE CBMSG

   CASE %WM_INITDIALOG
     DragAcceptFiles(hDlg, %TRUE)
     hEdit         = GetDlgItem(hDlg, %Edit)
     pEditProc     = SetWindowLong(hEdit, %GWL_WNDPROC, CODEPTR(EditProc)) 'Subclass the control
     hFontOri      = SendDlgItemMessage(hDlg, %Edit, %WM_GETFONT, 0, 0)
     hFontConsolas = FontMakeEx("Consolas", 9, 0, 0, 0)
     SendDlgItemMessage(hDlg, %Edit, %EM_LIMITTEXT, 0, 0) 'Set max lenght

     LOCAL sCommand AS STRING
     sCommand = COMMAND$
     IF LEN(sCommand) THEN
       OPEN sCommand FOR BINARY AS #1 : sData = NUL$(LOF(1)) : GET$ #1, LOF(1), sData : CLOSE #1
       DIALOG SET TEXT hDlg, $AppName & " [" & sCommand & "]"
     ELSE
       sData = $CRLF & _
               "Dummy text with CR, LF, and CRLF for testing" & $CRLF & _
               "Drop from Windows Explorer supported" & $CRLF & _
               "-" & $CRLF & _
               "A     a" & $CRLF & _
               "B" & $TAB & "b" & $CRLF & _
               "C" & $CRLF & _
               CHR$(1,2,3,4,5,6,7,8,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31) & $CRLF & _
               "?????" & CHR$(130,132,132,164,133) & $CRLF & _
               "cr" & $CR & "cr lf" & $LF & "lf" '& $CRLF '& _ '
     END IF
     CONTROL SET TEXT hDlg, %Edit, sData

   CASE %WM_COMMAND
     SELECT CASE CBCTL

       CASE %Edit
         IF HIWRD(CBWPARAM) = %EN_CHANGE THEN
         END IF
         IF (CBCTLMSG = %EN_KILLFOCUS) THEN
           SendMessage(CBLPARAM, %EM_GETSEL, VARPTR(SelStart), VARPTR(SelEnd))
           IF IsDlgButtonChecked(hDlg, %OptionViewAsText) THEN
             CONTROL GET TEXT hDlg, %Edit TO sData
           END IF
         END IF
         IF (CBCTLMSG = %EN_SETFOCUS) THEN
           SendMessage(CBLPARAM, %EM_SETSEL, SelStart, SelEnd)
         END IF

       CASE %ButtonConvert
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN

           IF IsDlgButtonChecked(hDlg, %OptionCrlfWindows) THEN
             LFCR = %Window '3
           ELSEIF IsDlgButtonChecked(hDlg, %OptionCrlfUnix) THEN
             LFCR = %Unix '2
           ELSEIF IsDlgButtonChecked(hDlg, %OptionCrlfMac) THEN
             LFCR = %Mac '1
           END IF '%OptionCrlfNoConversion

           IF IsDlgButtonChecked(hDlg, %OptionTabToSpace) THEN
             TabLen = GetDlgItemInt(hDlg, %EditTabLen, %FALSE, %FALSE)
           END IF
           IF IsDlgButtonChecked(hDlg, %OptionTabFromSpace) THEN '%OptionTabNoConversion
             TabLen = 0 - GetDlgItemInt(hDlg, %EditTabLen, %FALSE, %FALSE)
           END IF

           IF IsDlgButtonChecked(hDlg, %OptionBelow32Spc) THEN
             Below32      = %TRUE 'WinBeep(500, 100)
             zBelow32Char = $SPC
           END IF '%OptionBelow32SpcCharNoConvert
           IF IsDlgButtonChecked(hDlg, %OptionBelow32Custom) THEN
             Below32     = %TRUE 'WinBeep(500, 100)
             CONTROL GET TEXT hDlg, %EditCtrlChar TO zBelow32Char
           END IF '%OptionBelow32SpcCharNoConvert
           IF IsDlgButtonChecked(hDlg, %OptionBelow32Braket) THEN
             Below32      = %TRUE 'WinBeep(500, 100)
             zBelow32Char = "" '[]"
           END IF

           Convert(sData, LFCR, TabLen, Below32, zBelow32Char) 'MSGBOX HEX$(STRPTR(sData))
           PostMessage(hEdit, %EM_SETREADONLY, %FALSE, %NULL)
           CONTROL SET TEXT hDlg, %Edit, sData
           CONTROL SET OPTION hDlg, %OptionViewAsText, %OptionViewAsText, %OptionViewHelp
         END IF

       CASE %OptionViewAsText
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN
           SendDlgItemMessage(hDlg, %Edit, %WM_SETFONT, hFontOri, 0)
           PostMessage(hEdit, %EM_SETREADONLY, %FALSE, %NULL)
           CONTROL SET TEXT hDlg, %Edit, sData
         END IF

       CASE %OptionViewAsHex
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN
           sHex = HexView$(sData)
           SendDlgItemMessage(hDlg, %Edit, %WM_SETFONT, hFontConsolas, 0)
           CONTROL SET TEXT hDlg, %Edit, sHex
           PostMessage(hEdit, %EM_SETREADONLY, %TRUE, %NULL)
         END IF

       CASE %OptionViewHelp
           SendDlgItemMessage(hDlg, %Edit, %WM_SETFONT, hFontOri, 0)
           CONTROL SET TEXT hDlg, %Edit, "Help:" & $CRLF & "0-31 do not include Chr TAB-09, LF-10, and CR-13"
           PostMessage(hEdit, %EM_SETREADONLY, %TRUE, %NULL)

       CASE %OptionViewCount
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN
           PostMessage(hEdit, %EM_SETREADONLY, %FALSE, %NULL)
           SendDlgItemMessage(hDlg, %Edit, %WM_SETFONT, hFontConsolas, 0)
           sStat = sData
           Convert(sStat, %Stat, %FALSE, %FALSE, $NUL) '%Stat = 4
           CONTROL SET TEXT hDlg, %Edit, sStat
         END IF

       CASE %ButtonLFCR 'CRLF182? LF163? space133? tab187? cr171? lf172? 149?
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN
           GOSUB BraketView
         END IF

       CASE %ButtonTab
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN
           GOSUB BraketView
         END IF

       CASE %ButtonBelow32Char
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN
           GOSUB BraketView
         END IF

       CASE %ButtonAbove127
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN '?
           GOSUB BraketView
         END IF

       CASE %ButtonCharZero
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN
           GOSUB BraketView
         END IF

       CASE %ButtonClip
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN
           ClipBoardSet(sData)
         END IF

       CASE %ButtonSave
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN
           FileSave("123")
         END IF

       CASE %ButtonSaveAS
         IF (CBCTLMSG = %BN_CLICKED) OR (CBCTLMSG = 1) THEN
           FileGet("123")
         END IF

     END SELECT

   CASE %WM_DROPFILES
     LOCAL DragFileCount AS LONG
     LOCAL sFileList     AS STRING
     LOCAL zFileName     AS ASCIIZ * %MAX_PATH
     DragFileCount = DragQueryFile(CBWPARAM, &hFFFFFFFF???, BYVAL 0, 0)
     FOR Looper = 0 TO DragFileCount - 1
       DragQueryFile(CBWPARAM, Looper, zFileName, SIZEOF(zFileName))
       sFileList = sFileList & zFileName & "/" 'Could use $CRLF \/:*?<>|
     NEXT : sFileList = LEFT$(sFileList, -1)
     DragFinish(CBWPARAM) 'Releases memory that Windows allocated
     zFileName = PARSE$(sFileList, $CRLF, 1) 'Take only first file
     OPEN zFileName FOR BINARY AS #1 : sData = NUL$(LOF(1)) : GET$ #1, LOF(1), sData : CLOSE #1
     CONTROL SET TEXT hDlg, %Edit, sData '"D:\Tmp\garySort01.png"
     DIALOG SET TEXT hDlg, $AppName & " [" & zFileName & "]"

   CASE %WM_SIZE 'xPos,yPos, width, height  %WM_NCCALCSIZE
     IF CBWPARAM <> %SIZE_MINIMIZED THEN
       SetWindowPos(hEdit, %NULL, 2, 102, LOWRD(CBLPARAM) - 4, HIWRD(CBLPARAM) - 103, %SWP_NOZORDER)
     END IF

   CASE %WM_DESTROY
     SetWindowLong(hEdit, %GWL_WNDPROC, pEditProc)
     IF hFontConsolas THEN DeleteObject(hFontConsolas)

 END SELECT

 EXIT FUNCTION '--------------------------------------------------------------

 BraketView:
 sBuffer = sData
 LOCAL ButtonPushedStat AS DWORD
 IF IsDlgButtonChecked(hDlg, %ButtonAbove127) THEN '
   Looper = 128
   DO
     REPLACE CHR$(Looper) WITH "[" & FORMAT$(Looper) & "]" IN sBuffer
     INCR Looper
   LOOP WHILE Looper < 256
   ButtonPushedStat = 1
 END IF
 IF IsDlgButtonChecked(hDlg, %ButtonTab) THEN '
   REPLACE $TAB WITH "[tab]" IN sBuffer '187?
   ButtonPushedStat = ButtonPushedStat + 2
 END IF

 IF IsDlgButtonChecked(hDlg, %ButtonBelow32Char) THEN '
   Looper = 0
   DO
     REPLACE CHR$(Looper) WITH "[" & FORMAT$(Looper) & "]" IN sBuffer
     INCR Looper
     IF Looper = 09 THEN Looper = 11
     IF Looper = 13 THEN Looper = 14
   LOOP WHILE Looper < 32
   ButtonPushedStat = ButtonPushedStat + 4
 END IF
 IF IsDlgButtonChecked(hDlg, %ButtonLFCR) THEN '
   REPLACE $CRLF WITH "[crlf]" & CHR$(8) IN sBuffer '182?  20
   REPLACE $CR   WITH "[cr]" & $CR IN sBuffer '171? 027 017 014
   REPLACE $LF   WITH "[lf]" & $LF IN sBuffer '172?
   REPLACE "[crlf]" & CHR$(8) WITH "[crlf]" & $CRLF IN sBuffer '182?  20
   ButtonPushedStat = ButtonPushedStat + 8
 END IF
 SendDlgItemMessage(hDlg, %Edit, %WM_SETFONT, hFontOri, 0)
 IF ButtonPushedStat THEN
   CONTROL SET TEXT hDlg, %Edit, sBuffer
   PostMessage(hEdit, %EM_SETREADONLY, %TRUE, %NULL)
 ELSE
   PostMessage(hEdit, %EM_SETREADONLY, %FALSE, %NULL)
   CONTROL SET TEXT hDlg, %Edit, sData
 END IF
 RETURN

END FUNCTION
'_____________________________________________________________________________

FUNCTION PBMAIN()
 LOCAL hDlgIcon AS DWORD

 DIALOG FONT "Segoe UI", 9
 DIALOG NEW %HWND_DESKTOP, $AppName, , , 320, 200, _
 %WS_CAPTION OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX OR %WS_SYSMENU OR %WS_THICKFRAME, %WS_EX_ACCEPTFILES TO hDlg

 hDlgIcon = LoadIcon(GetModuleHandle(BYVAL 0), BYVAL 101)
 SetClassLong(hDlg, %GCL_HICON, hDlgIcon)

 CONTROL ADD FRAME, hDlg, -1, "View", 1, 1, 54, 52
 CONTROL ADD FRAME, hDlg, -1, "[View]", 55, 1, 41, 52
 CONTROL ADD FRAME, hDlg, -1, "CRLF convert", 96, 1, 63, 52
 CONTROL ADD FRAME, hDlg, -1, "Tab convert", 159, 1, 63, 52
 CONTROL ADD FRAME, hDlg, -1, "Control convert", 222, 1, 63, 52

 CONTROL ADD OPTION, hDlg, %OptionViewAsText, "View as text", 4, 10, 50, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP OR %WS_GROUP, %WS_EX_LEFT
 CONTROL ADD OPTION, hDlg, %OptionViewAsHex, "View as hex", 4, 20, 50, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP, %WS_EX_LEFT
 CONTROL ADD OPTION, hDlg, %OptionViewCount, "Text info", 4, 30, 50, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP, %WS_EX_LEFT
 CONTROL ADD OPTION, hDlg, %OptionViewHelp, "Help", 4, 40, 50, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP, %WS_EX_LEFT
 CONTROL SET OPTION hDlg, %OptionViewAsText, %OptionViewAsText, %OptionViewHelp

 CONTROL ADD BUTTON, hDlg, %ButtonLFCR        , "LF-CR", 58, 10, 35, 10, %BS_AUTOCHECKBOX OR %BS_PUSHLIKE OR %BS_CENTER OR %BS_VCENTER OR %WS_TABSTOP, %WS_EX_LEFT
 CONTROL ADD BUTTON, hDlg, %ButtonTab         , "TAB-SPC"  , 58, 20, 35, 10, %BS_AUTOCHECKBOX OR %BS_PUSHLIKE OR %BS_CENTER OR %BS_VCENTER OR %WS_TABSTOP, %WS_EX_LEFT

 CONTROL ADD BUTTON, hDlg, %ButtonBelow32Char , "0 to 31"  , 58, 30, 35, 10, %BS_AUTOCHECKBOX OR %BS_PUSHLIKE OR %BS_CENTER OR %BS_VCENTER OR %WS_TABSTOP, %WS_EX_LEFT

 CONTROL ADD BUTTON, hDlg, %ButtonAbove127    , "127 to 255" , 58, 40, 35, 10, %BS_AUTOCHECKBOX OR %BS_PUSHLIKE OR %BS_CENTER OR %BS_VCENTER OR %WS_TABSTOP, %WS_EX_LEFT


 CONTROL ADD OPTION, hDlg, %OptionCrlfWindows      , "Windows CRLF", 100, 10, 54, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP OR %WS_GROUP, %WS_EX_LEFT
 CONTROL ADD OPTION, hDlg, %OptionCrlfUnix         , "Unix LF"     , 100, 20, 52, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP, %WS_EX_LEFT
 CONTROL ADD OPTION, hDlg, %OptionCrlfMac          , "Mac CR"      , 100, 30, 52, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP, %WS_EX_LEFT
 CONTROL ADD OPTION, hDlg, %OptionCrlfNoConversion , "Do not convert", 100, 40, 56, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP, %WS_EX_LEFT
 CONTROL SET OPTION hDlg, %OptionCrlfNoConversion, %OptionCrlfWindows, %OptionCrlfNoConversion

 CONTROL ADD LABEL  , hDlg, %LabelTab, "Tab lenght", 185, 10, 35, 10

 CONTROL ADD TEXTBOX, hDlg, %EditTabLen, "2", 165, 10, 18, 9, _
 %ES_NUMBER OR %ES_LEFT OR %ES_AUTOHSCROLL OR %WS_TABSTOP, %WS_EX_STATICEDGE

 CONTROL ADD OPTION, hDlg, %OptionTabToSpace      , "Tab to space"  , 165, 20, 52, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP OR %WS_GROUP, %WS_EX_LEFT
 CONTROL ADD OPTION, hDlg, %OptionTabFromSpace    , "Space to tab"  , 165, 30, 55, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP, %WS_EX_LEFT
 CONTROL ADD OPTION, hDlg, %OptionTabNoConversion , "Do not convert"     , 165, 40, 56, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP, %WS_EX_LEFT
 CONTROL SET OPTION hDlg, %OptionTabNoConversion, %OptionTabToSpace, %OptionTabNoConversion

 CONTROL ADD OPTION, hDlg, %OptionBelow32Spc      , "0-31 to space", 225, 10, 50, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP OR %WS_GROUP, %WS_EX_LEFT
 ToolTipAdd(hDlg, %OptionBelow32Spc, "Excluding TAB CR LF")
 CONTROL ADD OPTION, hDlg, %OptionBelow32Custom   , "0-31 to ", 225, 20, 30, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP, %WS_EX_LEFT
 ToolTipAdd(hDlg, %OptionBelow32Custom, "Excluding TAB CR LF")
 CONTROL ADD TEXTBOX, hDlg, %EditCtrlChar, ".", 260, 20, 10, 9, %ES_LEFT OR %ES_AUTOHSCROLL OR %WS_TABSTOP, %WS_EX_STATICEDGE
 CONTROL ADD OPTION, hDlg, %OptionBelow32Braket, "[0 to 31]", 225, 30, 56, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP, %WS_EX_LEFT
 CONTROL DISABLE hDlg, %OptionBelow32Braket
 CONTROL ADD OPTION, hDlg, %OptionBelow32SpcCharNoConvert , "Do not convert"   , 225, 40, 56, 10, %BS_LEFT OR %BS_VCENTER OR %BS_NOTIFY OR %WS_TABSTOP, %WS_EX_LEFT
 CONTROL SET OPTION hDlg, %OptionBelow32SpcCharNoConvert, %OptionBelow32Spc, %OptionBelow32SpcCharNoConvert

 CONTROL ADD BUTTON, hDlg, %ButtonConvert     , "Convert", 288, 03, 30, 10
 ToolTipAdd(hDlg, %ButtonConvert, "Convert")
 CONTROL ADD BUTTON, hDlg, %ButtonClip        , "Clip"   , 288, 13, 30, 10
 CONTROL ADD BUTTON, hDlg, %ButtonSave        , "Save"   , 288, 23, 30, 10
 CONTROL DISABLE hDlg, %ButtonSave
 CONTROL ADD BUTTON, hDlg, %ButtonSaveAs      , "Save as", 288, 33, 30, 10
 CONTROL DISABLE hDlg, %ButtonSaveAs

 CONTROL ADD TEXTBOX, hDlg, %Edit, "", 2, 2, 196, 96, %WS_CHILD OR %WS_VISIBLE OR _
 %WS_TABSTOP OR %WS_HSCROLL OR %WS_VSCROLL OR %ES_LEFT OR %ES_MULTILINE OR _
 %ES_NOHIDESEL OR %ES_AUTOHSCROLL OR %ES_AUTOVSCROLL OR %ES_WANTRETURN, _
 %WS_EX_CLIENTEDGE OR %WS_EX_LEFT OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR

 DIALOG SHOW MODAL    hDlg CALL DlgProc
 DestroyIcon(hDlgIcon)

END FUNCTION
'_____________________________________________________________________________
'